// Generated by CoffeeScript 2.3.2
(function() {
    const ConnectionFactory = require('sql-client/lib/connection-factory').ConnectionFactory;
    const SQLClient         = require('sql-client/lib/sql-client').SQLClient;
    const SQLClientPool     = require('sql-client/lib/sql-client-pool').SQLClientPool;
    const mssql             = require('mssql');

    const MSSQLConnectionFactory = class MSSQLConnectionFactory extends ConnectionFactory {
        constructor() {
            super(...arguments);
            this.open_connection = this.open_connection.bind(this);
            this.execute = this.execute.bind(this);
        }

        open_connection(options, callback) {
            let connection;
            const pos = options.server.indexOf(':');
            if (pos !== -1) {
                options.port = parseInt(options.server.substring(pos + 1), 10);
                options.server = options.server.substring(0, pos);
            }
            options.pool = options.pool || {};
            options.pool.min = 0;
            options.pool.max = 1;

            return connection = new mssql.ConnectionPool(options, err => {
                if (err != null) {
                    return callback(err);
                } else {
                    return callback(null, connection);
                }
            });
        };

        execute(connection, sql, bindvars, callback) {
            const request = new mssql.Request(connection);
            return request.query(sql, (err, result) => callback(err, result && result.recordset ? result.recordset : result));
        };
    };

    const MSSQLClient = class MSSQLClient extends SQLClient {
        constructor(...options) {
            super(...options, new MSSQLConnectionFactory());
        }

    };

    const MSSQLClientPool = class MSSQLClientPool extends SQLClientPool {
        constructor(...options) {
            super(...options, new MSSQLConnectionFactory());
        }

    };

    exports.MSSQLConnectionFactory = MSSQLConnectionFactory;

    exports.MSSQLClient = MSSQLClient;

    exports.MSSQLClientPool = MSSQLClientPool;

}).call(this);
